
// aesSampleDlg.h : wb_[ t@C
//

#pragma once

#include <Strsafe.h>
#include <emmintrin.h>

#ifndef	STR_MAX_LENGTH
#define	STR_MAX_LENGTH	256
#endif

#define	CPH_BUF_SIZE		(64 * 1024 * 1024)
#define	CPH_THRESHOLD_SIZE	( 1 * 1024 * 1024)
#define	CPH_HALF_SIZE(sz)	(((sz / 2) + (AES_BLK_BYTE - 1)) & ~(AES_BLK_BYTE - 1))

class CaesSampleDlg;

typedef	union{
	FILETIME	fileTime;
	UINT64		val64;
}UnTmData;

typedef	struct {
	BYTE	*pBuffer;
	ULONG	*pExtKey;
	BYTE	cbcInt[AES_BLK_BYTE];
	UCHAR	*pCtrIvec;
	UCHAR 	*pCtrNonce;
	CaesSampleDlg	*pThis;
	PROC_TYPES	proType;
	int		keyType;
	ULONG	dataSize;
	ULONG	ctrCount;
}StThParam;

// CaesSampleDlg _CAO
class CaesSampleDlg : public CDialogEx
{
// RXgNV
public:
	CaesSampleDlg(CWnd* pParent = NULL);	// WRXgN^[
	~CaesSampleDlg();						// WfXgN^[

// _CAO f[^
	enum { IDD = IDD_AESSAMPLE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
private:
	int m_iAlgorithmSelect;
	int m_iThreadSelect;
	int m_iCipherSelect;
	int m_iKeyLength;
	int m_iAesInstruction;
	CString m_strAesKey128;
	CString m_strAesKey192;
	CString m_strAesKey256;
	CString m_strAesCbcIvec;
	CString m_strAesCtrIvec;
	CString m_strAesCtrNonce;
	CString m_strInputFile;
	CString m_strOutputFile;
	CString m_strExecuteResult;
public:
	afx_msg void OnBnClickedButtonExecute();
	afx_msg void OnBnClickedButtonEnd();
	afx_msg void OnBnClickedRadioAesCipher();
	afx_msg void OnBnClickedRadioCamCipher();
	afx_msg void OnBnClickedRadioAes128();
	afx_msg void OnBnClickedRadioAes192();
	afx_msg void OnBnClickedRadioAes256();
	afx_msg void OnBnClickedRadioClassCbcEnc();
	afx_msg void OnBnClickedRadioClassCbcDec();
	afx_msg void OnBnClickedRadioClassCbcMac();
	afx_msg void OnBnClickedRadioClassEcbEnc();
	afx_msg void OnBnClickedRadioClassEcbDec();
	afx_msg void OnBnClickedRadioClassCtr();
	afx_msg void OnBnClickedButtonInputReference();
	afx_msg void OnBnClickedButtonOutputReference();
	afx_msg void OnEnKillfocusEditKey0();
	afx_msg void OnEnKillfocusEditKey1();
	afx_msg void OnEnKillfocusEditKey2();
	afx_msg void OnEnKillfocusEditCbcInt();
	afx_msg void OnEnKillfocusEditCtrIvec();
	afx_msg void OnEnKillfocusEditCtrNonce();

public:
	static UINT WINAPI AesCbcDecryptThread(PVOID lpParameter);
	static UINT WINAPI AesEcbEncryptThread(PVOID lpParameter);
	static UINT WINAPI AesEcbDecryptThread(PVOID lpParameter);
	static UINT WINAPI AesCtrEncryptThread(PVOID lpParameter);
	static UINT WINAPI CamCbcDecryptThread(PVOID lpParameter);
	static UINT WINAPI CamEcbEncryptThread(PVOID lpParameter);
	static UINT WINAPI CamEcbDecryptThread(PVOID lpParameter);
	static UINT WINAPI CamCtrEncryptThread(PVOID lpParameter);

private:
	bool m_fInputFile;
	bool m_fOutputFile;
	bool m_fInOutFile;
	PROC_STATUS m_stProcStatus;
	int m_iInputHandle;
	int m_iOutputHandle;
	struct _stati64 m_sStat64; 
	__int64 m_i64SeekPoint;
	BYTE *m_pbCphBuffer;
	BYTE m_bCipherKey[2][AES_BLK_BYTE];
	BYTE m_bCbcInt[AES_BLK_BYTE];
	BYTE m_bCbcMac[AES_BLK_BYTE];
	UCHAR m_bCtrIvec[8];
	UCHAR m_bCtrNonce[4];
	UINT64 m_u64StartTime;
	UINT64 m_u64Integration;
	StThParam m_stThreadParam;

private:
	void GetCnvHexByte(BYTE *pCnv,CString &src,int length);
	HRESULT GetInputFileName(CString *pFileName,HWND hwnd = NULL);
	HRESULT GetOutputFileName(CString *pFileName,HWND hwnd = NULL);
	void ChkKillfocusHex(int nID,int length);
	PROC_TYPES GetProcType(int aesInstruction){
		switch(aesInstruction){
		case	0:	return PROC_AUTO;
		case	1:	return PROC_X86_X64;
		case	2:	return PROC_SSE;
		case	3:	return PROC_SSSE3;
		case	4:	return PROC_AES_NI;
		default:	return PROC_X86_X64;
		}
	}
	AES_TYPES GetAesType(int aesKeyLength){
		switch(aesKeyLength){
		case	1:	return AES_TYPE_192;
		case	2:	return AES_TYPE_256;
		default:	return AES_TYPE_128;
		}
	}
	CAM_TYPES GetCamType(int camKeyLength){
		switch(camKeyLength){
		case	1:	return CAM_TYPE_192;
		case	2:	return CAM_TYPE_256;
		default:	return CAM_TYPE_128;
		}
	}
	void AesCbcEncrypt();
	void AesCbcDecrypt();
	void AesCbcMac();
	void AesEcbEncrypt();
	void AesEcbDecrypt();
	void AesCtrEncrypt();
	void CamCbcEncrypt();
	void CamCbcDecrypt();
	void CamCbcMac();
	void CamEcbEncrypt();
	void CamEcbDecrypt();
	void CamCtrEncrypt();
	void AesCnvResult(TCHAR *pTtl,ULONG64 length,ULONG64 time);
	bool AesInputFileOpen();
	bool AesOutputFileOpen();
	int AesInputFileRead(void *pData,ULONG size);
	int AesOutputFileWrite(void *pData,ULONG size);
	void AesInputFileClose();
	void AesOutputFileClose();
};
